#define _GNU_SOURCE
#include <dlfcn.h>
#include <stdio.h>
#include <setjmp.h>
#include <unistd.h>
int condition;
jmp_buf buf;
void exit_continuation_function (int);
void exit_register_continuation (void (*exit_continuation_function) (int status))
{
  void (*wrap_exit_register_continuation) (void (*) (int));
  wrap_exit_register_continuation = dlsym (RTLD_NEXT, "wrap_exit_register_continuation");
  (*wrap_exit_register_continuation) (exit_continuation_function);
}
void exit_set_condition (int condition)
{
  void (*wrap_exit_set_continuation_condition) (int);
  wrap_exit_set_continuation_condition = dlsym (RTLD_NEXT, "wrap_exit_set_continuation_condition");
  (*wrap_exit_set_continuation_condition) (condition);
}
void exit_continuation_function (int status)
{
  printf ("escaping _exit (%d);\n", status);
  condition = 0;
  exit_set_condition (0);
  longjmp (buf, 1);
}
int main ()
{
  exit_register_continuation (exit_continuation_function);
  exit_set_condition (1);
  condition = 1;
  setjmp (buf);
  if (condition)
    {
      printf ("before _exit (1);\n");
      _exit (1);
    }
  printf ("after _exit (1);\n");
}
