#define _GNU_SOURCE
#include <dlfcn.h>
void (*wrap_exit_continuation_function) ();
int wrap_exit_continuation_condition;
void wrap_exit_register_continuation (void (*exit_continuation_function) (int status))
{
  wrap_exit_continuation_function = exit_continuation_function;
}
void wrap_exit_set_continuation_condition (int condition)
{
  wrap_exit_continuation_condition = condition;
}
void _exit (int status)
{
  void (*actual_exit) (int status);
  actual_exit = dlsym (RTLD_NEXT, "_exit");
  if (wrap_exit_continuation_condition)
    (*wrap_exit_continuation_function) (status);
  else
    (*actual_exit) (status);
  while (1);
}
